import {Request, Response} from 'express';
import {Model} from 'mongoose';

const create = (model: Model<any>) => (req: Request, res: Response) => {
	console.log(`Create new document for ${model.modelName}`);

	const doc = new model({
		...req.body,
	});

	return doc
		.save()
		.then((result: any) => res.status(201).send(result))
		.catch((error: any) => res.status(500).json({error}));
};

const getAll = (model: Model<any>) => (req: Request, res: Response) => {
	console.log(`Getting all documents for ${model.modelName}`);

	model
		.find<Document>({}, {description: 0})
		.then((results) => {
			console.log(results);
			return res.status(200).send(results);
		})
		.catch((error) => {
			console.log(error);
			return res.status(500).json({error});
		});
};

export default {
	create,
	getAll,
};
